"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../common/util");
const UpdateChanges_1 = require("../common/UpdateChanges");
const version = '8.2.6';
function default_1() {
    return (host, context) => {
        const themes = ['$_base-dark-grid-pagination',
            '$_dark-grid-pagination',
            '$_dark-fluent-grid-pagination',
            '$_light-grid-pagination',
            '$_fluent-grid-pagination',
            '$_round-shape-grid-pagination',
            '$_default-shape-grid-pagination',
            '$_square-shape-grid-pagination'];
        const newThemes = ['$_base-dark-pagination',
            '$_dark-pagination',
            '$_dark-fluent-pagination',
            '$_light-pagination',
            '$_fluent-pagination',
            '$_round-shape-pagination',
            '$_default-shape-pagination',
            '$_square-shape-pagination'];
        let globalStyleExt;
        const config = util_1.getWorkspace(host);
        const projects = util_1.getProjects(config);
        context.logger.info(`Applying migration for Ignite UI for Angular to version ${version}`);
        if (config.schematics && config.schematics['@schematics/angular:component']) {
            // updated projects have global prefix rather than per-project:
            globalStyleExt = config.schematics['@schematics/angular:component'].styleext;
        }
        for (const proj of projects) {
            const dir = host.getDir(proj.sourceRoot);
            let ext = globalStyleExt || 'scss';
            if (proj.schematics && proj.schematics['@schematics/angular:component']) {
                ext = proj.schematics['@schematics/angular:component'].styleext || ext;
            }
            dir.visit((path, entry) => {
                if (path.endsWith('.' + ext)) {
                    let content = entry.content.toString();
                    if (content.match(/\bigx-grid-paginator\b/g)) {
                        content = content.replace(/\bigx-grid-paginator\b/g, 'igx-paginator');
                    }
                    themes.forEach((n, i) => {
                        if (content.indexOf(n) !== -1) {
                            content = content.split(n).join(newThemes[i]);
                        }
                    });
                    host.overwrite(path, content);
                }
            });
        }
        const update = new UpdateChanges_1.UpdateChanges(__dirname, host, context);
        update.applyChanges();
    };
}
exports.default = default_1;
